#ifndef DEBUG_H_
#define DEBUG_H_

/**
@file
@brief Макросы для сбора и вывода отладочной информации.

В отключенном состоянии не влияют на производительность кода.

Для отключения данных макросов установите дефайн NDEBUG
*/
#include <cassert>

#ifndef NDEBUG

#include <iostream>

/**
@brief Выполнение оператора и отображение его имени в std::cout

При отключении дебага оператор всё равно выполняется!
*/
#define TRACE(ARG) std::cout << #ARG << std::endl; ARG;

/**
@brief Отображение в std::cout имени и значения переменной или функции

При отключении дебага переданная функция тоже перестаёт выполняеться!

@param x Переменная или функция любого типа, поддерживающая вывод в поток
*/
#define PR(x) std::cout << #x " = " << (x) << std::endl;

/// Вывод сообщения в std::cout
#define MSG(x) std::cout << #x << std::endl;

/**
@brief Генерация ошибки сегментации

Аналог abort(), но работает ненадёжно
*/
#define COREDUMP() void *a = 0, *b; b* = *a;

#else

// В случае если дебаг отключен макросы заменяются на заглушки:
#define TRACE(ARG) {}; ARG;
#define PR(x) {};
#define MSG(x) {};
#define COREDUMP() {};

#endif

#endif

/**
@fn assert( value )
@brief Проверка на условия на верность во время выполнения программы

Функция для проверки правильности входных данных в начале
выполнения кода функции. Позволяет быстро находить и избавиться от
редких трудноуловимых быгов по причине выхода из допустимого
диапазона значений данных.

Удобно использовать в начале блока кода для проверки условий и в
конце для проверки результата.

@param value Значение, истинность которого проверяется
*/
